/* reports.c
 * ---------
 * Reports parsing/creation functions
 * ---------
 *
 * PTlink Services is (C) CopyRight PTlink Coders Team 1999 
 * http://www.ptlink.net/Coders - coders@PTlink.net
 * This program is distributed under GNU Public License
 *
 * Please read the file COPYING for copyright information.
*/
#include "services.h"
#include "pseudo.h"
#define REP_BUF_SIZE 512 /* report buffer size */


/************************************************
    Reads text lines from file into buffer  
    will stop when [END] is found
 ************************************************/
void read_until_end(FILE* file,char* buffer){
    char *place;
    place = buffer;
    while(feof(file)) {
	fgets(file,place,REP_BUF_SIZE);
	if(!strcmp(place,"[END]\n")) return;
	place+=strlen(place);
    }
    fprintf(stderr,"SRT Error: Missing [END]",templ);
    exit(2);    
};

/************************************************
    Creates a report using a template
 ************************************************/
void reportchans(const char *templ, const char *report)
{
    int count = 0;
    ChannelInfo *ci;
    int i;    
    FILE *tempfile;  	/* Template file */
    FILE *outfile;   	/* output file */
    char buffer[REP_BUF_SIZE]; 	/* buffer storage */
    char cmd; 		/* tag command */
    if (!(tempfile = fopen(templ,"rt")) {
	fprintf(stderr,"Error opening services report template: %s\n",templ);
	exit(2);
    }
    if (!(outfile = fopen(report,"wt")) {
	fprintf(stderr,"Error creating report file: %s\n",report);
	exit(2);
    }
    while(!feof(tempfile)) {
	fgets(tempfile,buffer,REP_BUF_SIZE);
	if (buffer[0]=='#') continue:
	if (buffer[0]=='[') {
	    tag=strtok(buffer,' ');
	    if(!strcmp(tag,"[HEADER]" || !strcmp(tag,"[FOOTER]")) {
		read_until_end(tempfile,buffer);
		(void) general_parse(outfile,buffer);
	    }
	    if(!strcmp(tag,"[RECORD]")) {
		read_until_end(tempfile,buffer);
		for (i = 0; i < 256; i++) {
		    for (ci = chanlists[i]; ci; ci = ci->next) {
			chanserv_parse(outfile,buffer,ci);
			count++;
		    }
		}
	    }
	}
    }
}

